# 002. Add Two Numbers

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/add-two-numbers/description/

> 内容描述

You are given two non-empty linked lists representing two non-negative integers. The digits are stored in reverse order and each of their nodes contain a single digit. Add the two numbers and return it as a linked list.

You may assume the two numbers do not contain any leading zero, except the number 0 itself.


#### Example:
    
    Input: (2 -> 4 -> 3) + (5 -> 6 -> 4)
    Output: 7 -> 0 -> 8
    Explanation: 342 + 465 = 807.

## 解题方案

> 思路 1
******- 时间复杂度: O(max(m,n))******- 空间复杂度: O(max(m,n))******

```javascript
/**
 * Definition for singly-linked list.
 * function ListNode(val) {
 *     this.val = val;
 *     this.next = null;
 * }
 */
/**
 * @param {ListNode} l1
 * @param {ListNode} l2
 * @return {ListNode}
 */
let addTwoNumbers = function (l1,l2) {
    let result = new ListNode(0),
        node = result;
    while(l1 || l2){
        let r = node.val,
            i = (l1 && l1.val) || 0,
            j = (l2 && l2.val) || 0,
            sum = r + i + j,
            m,n;
        if(sum >= 10){
            m = 1;
            n = sum - 10;
        }else{
            m = 0;
            n = sum;
        }
        l1 = l1 && l1.next;
        l2 = l2 && l2.next;
        node.val = n;
        if(m || l1 || l2){
            node.next = new ListNode(m);
            node = node.next
        }
    }
    return result;
};

function ListNode(val) {
    this.val = val;
    this.next = null;
}
```

